about summary refs log tree commit homepage
path: root/script
diff options
context:
space:
mode:
authorEric Wong <e@yhbt.net>2020-05-26 09:05:24 +0000
committerEric Wong <e@yhbt.net>2020-05-27 22:31:27 +0000
commitace6491217a6aa894ca82c967c42f1df168d7855 (patch)
tree58b7ce4fb6a7e2b370ddc9b1f594b1f853d6639e /script
parente97f478cd6ace58cbbe6287106f45f7809f5e8b1 (diff)
downloadpublic-inbox-ace6491217a6aa894ca82c967c42f1df168d7855.tar.gz
I found myself wanting to remove a message from all inboxes
while working on a test case in another branch.  I figure this
could also be useful for globally removing messages which are in
the grey area or too big for spamc.
Diffstat (limited to 'script')
-rw-r--r--script/public-inbox-learn9
1 files changed, 7 insertions, 2 deletions
diff --git a/script/public-inbox-learn b/script/public-inbox-learn
index 0cb2c8e9..5cd08d49 100644
--- a/script/public-inbox-learn
+++ b/script/public-inbox-learn
@@ -12,10 +12,15 @@ use PublicInbox::InboxWritable;
 use PublicInbox::Eml;
 use PublicInbox::Address;
 use PublicInbox::Spamcheck::Spamc;
+use Getopt::Long qw(:config gnu_getopt no_ignore_case auto_abbrev);
+my %opt = (all => 0);
+GetOptions(\%opt, 'all') or die "bad command-line args\n";
+
 my $train = shift or die "usage: $usage\n";
 if ($train !~ /\A(?:ham|spam|rm)\z/) {
         die "`$train' not recognized.\nusage: $usage\n";
 }
+die "--all only works with `rm'\n" if $opt{all} && $train ne 'rm';
 
 my $spamc = PublicInbox::Spamcheck::Spamc->new;
 my $pi_config = PublicInbox::Config->new;
@@ -68,12 +73,12 @@ sub remove_or_add ($$$$) {
 }
 
 # spam is removed from all known inboxes since it is often Bcc:-ed
-if ($train eq 'spam') {
+if ($train eq 'spam' || ($train eq 'rm' && $opt{all})) {
         $pi_config->each_inbox(sub {
                 my ($ibx) = @_;
                 $ibx = PublicInbox::InboxWritable->new($ibx);
                 my $im = $ibx->importer(0);
-                $im->remove($mime, 'spam');
+                $im->remove($mime, $train);
                 $im->done;
         });
 } else {